/* Database Copy */

-- Create a transactionally consistent copy of the database
CREATE DATABASE WineCloudDbCopy AS COPY OF WineCloudDb
GO

-- Monitor the copy status
SELECT name, state, state_desc
 FROM sys.databases
 WHERE name = 'WineCloudDbCopy'

-- Monitor the copy details (status, percent complete, and more)
SELECT *
 FROM sys.dm_database_copies AS c
  INNER JOIN sys.databases AS d ON c.database_id = d.database_id
 WHERE
  d.name = 'WineCloudDbCopy'
