﻿using System.Collections.Generic;
using System.Linq;

namespace WineCloudWebApi.Data
{
  public class Shard
  {
    public int Id { get; set; }
    public int BeginId { get; set; }
    public int EndId { get; set; }
    public string ConnectionString { get; set; }
  }

  public class ShardRoot
  {
    public ShardRoot() { Shards = new List<Shard>(); }
    public IList<Shard> Shards { get; private set; }
  }

  public class CustomerShard
  {
    private static CustomerShard _instance;
    private static object _lockObj = new object();

    public static CustomerShard Instance
    {
      get
      {
        if (_instance == null)
        {
          lock (_lockObj)
          {
            if (_instance == null)
            {
              _instance = new CustomerShard();
            }
          }
        }
        return _instance;
      }
    }

    public ShardRoot ShardRoot { get; private set; }

    public CustomerShard()
    {
      ShardRoot = new ShardRoot();
      ShardRoot.Shards.Add(new Shard
      {
        Id = 1,
        BeginId = 1,
        EndId = 1,
        ConnectionString = "Server=tcp:muea4g022x.database.windows.net,1433;Database=WineCloudDbShard1;User ID=saz@muea4g022x;Password=Paradox_0;Trusted_Connection=False;Encrypt=True;Connection Timeout=30;"
      });
      ShardRoot.Shards.Add(new Shard
      {
        Id = 2,
        BeginId = 2,
        EndId = 3,
        ConnectionString = "Server=tcp:muea4g022x.database.windows.net,1433;Database=WineCloudDbShard2;User ID=saz@muea4g022x;Password=Paradox_0;Trusted_Connection=False;Encrypt=True;Connection Timeout=30;"
      });
    }

    public Shard GetShard(int id)
    {
      return ShardRoot.Shards.FirstOrDefault(shard => shard.BeginId <= id && shard.EndId >= id);
    }
  }
}
